ModeX   proc
        mov ax, 0013h                   ; Allow BIOS to set 320x200x256x1
        int 10h                         ;

        mov dx, 3CEh                    ; Tell the Graphics Controller
        mov al, 5                       ; to change the graphics mode
        out dx, al                      ; (register 5) to use linear
        inc dx                          ; addresses instead of seperating
        in al, dx                       ; the odd and even addresses.
        and al, 11101111b               ;
        out dx, al                      ;
        dec dx                          ;

        mov al, 6                       ; Tell the Graphics Controller
        out dx, al                      ; to change the misc. register
        inc dx                          ; (register 6) to use linear
        in al, dx                       ; addresses instead of seperating
        and al, 11111101b               ; the odd and even addresses.
        out dx, al                      ;

        mov dx, 3C4h                    ; Tell the Sequencer Controller
        mov al, 4                       ; to change the memory mode
        out dx, al                      ; (register 4) to disable chain4
        inc dx                          ; mode, and allow linear
        in al, dx                       ; processing on a bitplane.
        and al, 11110111b               ;
        or al, 4                        ;
        out dx, al                      ;

        mov ax, 0A000h                  ; Clear the screen.
        mov es, ax                      ;
        xor di, di                      ;
        mov ax, di                      ;
        mov cx, 8000h                   ;
        rep stosw                       ;

        mov dx, 3D4h                    ; Tell the CRT Controller to
        mov al, 14h                     ; change the underline location
        out dx, al                      ; (register 14h) to turn off
        inc dx                          ; the double word mode.
        in al, dx                       ;
        and al, 10111111b               ;
        out dx, al                      ;
        dec dx                          ;

        mov al, 17h                     ; Tell the CRT Controller to
        out dx, al                      ; change the mode control
        inc dx                          ; (register 17h) to switch
        in al, dx                       ; to byte mode.
        or al, 01000000b                ;
        out dx, al                      ;

        mov dx, 3C2h                    ; Modify vertical timing
        mov al, 0E3h                    ; register to achieve square
        out dx, al                      ; aspect ratio.

        mov dx, 3D4h                    ; Modify vertical timing
        mov ax, 2C11h                   ; registers to adjust for
        out dx, ax                      ; new resolution
        mov ax, 0D06h                   ;
        out dx, ax                      ;
        mov ax, 3E07h                   ;
        out dx, ax                      ;
        mov ax, 0EA10h                  ;
        out dx, ax                      ;
        mov ax, 0AC11h                  ;
        out dx, ax                      ;
        mov ax, 0DF12h                  ;
        out dx, ax                      ;
        mov ax, 0E715h                  ;
        out dx, ax                      ;
        mov ax, 0616h                   ;
        out dx, ax                      ;

        ret
ModeX   ends
